<?php
	include("data/includes/config.inc.php");
	include("data/includes/ambunit.inc.php");

	$adbh = connect("$dbhost", "$dbu", "$dbpw", "$dbn");

	$aktdatetime = date("Y-m-d H:i:s");
	$search=array();
	
	$ergebnis = query($adbh, "SELECT serviceurl FROM autodl ORDER BY serviceurl ASC");
	while($row = fetch_object($ergebnis)) {
		if ( !$services ) {
			$services = array();
			$new = true;
		} else {		
			$new = false;
		}
		foreach ( $services as $s ) {
			if ( ($s != $row->serviceurl) ) {
				$new = true;
			}
		}
		if ( $new ) {
			array_push($services, $row->serviceurl);
		}
	}
	
	foreach($services as $service) {
		if ( substr($service, 0, 3) != "RSS" ) {
			$files = array();
			$ergebnis = query($adbh, "SELECT * FROM autodl WHERE serviceurl='$service'");
			while( $row = fetch_object($ergebnis) ) {
					$file = array(	"name" => "$row->name",
									"searchstr" => "$row->searchstr",
									"typ" => "$row->typ",
									"desc" => "$row->descr",
									"uploader" => "$row->uploader" );
					array_push( $files, $file );
			}
			$srch = array(	"service" => $service,
							"files" => $files );
			array_push( $search, $srch );
		}
	}
	
	foreach( $search as $s ) {
		echo "checking ". $s["service"] ."\r\n";
		echo "searching for: ";
		foreach( $s["files"] as $f ) {
			echo $f["name"] ." (". $f["searchstr"] ."); ";
		}
		echo"\r\n";
			if ( $rs = rssdecode( $s["service"] ) ) {
				foreach ( $rs["items"] as $r ) {
					foreach( $s["files"] as $f ) {
						if ( preg_match( $f["searchstr"], $r["title"] ) ) {
							$uploader = $f["uploader"];
							$typ = $f["typ"];
							$desc = $r["title"]  ." ". $f["desc"];
							echo "Found: ";
							echo $desc ."\r\n";
							if ( preg_match( "/(http\:\/\/.*?\.torrent)/i", $r["link"], $tu ) ) {
								$torrenturl = $tu[1];
							} elseif ( preg_match( "/(http\:\/\/.*?\.torrent)/i", $r["description"], $tu ) ) {
								$torrenturl = $tu[1];
							}
							echo "Torrent-URL: ". $torrenturl ."\r\n";
							preg_match( "/http\:\/\/.*\/(.*?\.torrent)/", $torrenturl, $dname );
							$dname[1] = urldecode($dname[1]);
						
							ini_set( 'user_agent', 'yaBTuc at '. $yabtucurl );
							if ( $f = @fopen($torrenturl, 'rb') ) {
								$torrent = '';
								while ( !feof($f) ) {
									$torrent .= fgets( $f, 4096 );
								}

								$torrarr = bdec($torrent);
								list($ann, $info) = dict_check($torrarr, "announce(string):info");
								list($dnme, $plen, $pieces) = dict_check($info, "name(string):piece length(integer):pieces(string)");
								$filelist = array();
								$anzfiles = 0;
								$totallen = dict_get($info, "length", "integer");
								if (isset($totallen)) {
									$filelist = array($dname, $totallen);
									$type = "single";
									$anzfiles = 1;
								} else {
									$flist = dict_get($info, "files", "list");
									if (!isset($flist))
										bark("missing both length and files");
									if (!count($flist))
										bark("no files");
									$totallen = 0;
									foreach ($flist as $fn) {
										list($ll, $ff) = dict_check($fn, "length(integer):path(list)");
										$totallen += $ll;
										$ffa = array();
										foreach ($ff as $ffe) {
											if ($ffe["type"] != "string")
												bark("filename error");
											$ffa[] = $ffe["value"];
										}
										if (!count($ffa))
											bark("filename error");
										$ffe = implode("/", $ffa);
										$filelist[] = array($ffe, $ll);
										$anzfiles++;
									}
									$type = "multi";
								}

								$totallen=round($totallen/1024000);
							
								$infohash = pack("H*", sha1($info["string"]));
								$enchash = pg_escape_string($infohash);
								echo"infohash: ".dechash($enchash)."\r\n";
								
								$scrape=str_replace("announce", "scrape", $ann);
								echo"announce-url: ".$ann."\r\n";
								echo"scrape-url: ".$scrape."\r\n";
								
								$ergebnis = query($adbh, "SELECT * FROM torrents WHERE hash='$enchash'");
								$row = fetch_object($ergebnis);
								if($row->name!="") {
										echo"allready downloaded...\r\n\r\n";
								} else {
									$torrentname = str_replace(" ", "_", $dname[1]);
				
									if ($f = @fopen($uldir . $torrentname, 'wb')) {
										fwrite ($f, $torrent, strlen($torrent));
										fclose($f);
									}
									
									$tr_info=check_tracker($scrape, $infohash);
									$dld=$tr_info["d"];
									$incomp=$tr_info["i"];
									$comp=$tr_info["c"];
								
/*	Wenn kein Name eingegeben wurde, aus
	dem filename uebernehmen
*/
									$purename = $torrentname;
	
/*	$purename bereinigen
*/
	
									$purename = str_replace(".torrent", "", $purename);
									$purename = str_replace("_", ".", $purename);
									$purename = str_replace(".", " ", $purename);
									$purename = chop($purename);
									$purename = str_replace(" ", ".", $purename);
									$purename = preg_replace("/\.+/", ".", $purename);
				
/*	Wenn kein Link angegeben wurde,
	es sich aber um einen Film, oder eine Serie handelt,
	Link selbst erstellen.
*/
	
									$search = preg_replace("/(\.avi|mpg|mpeg|\.ace|\.zip|\.rar|\.exe|\.iso|season|episode|mvcd|svcd|xvcd|vcd|dvd-r|dvd|xvid|divx|div-x|ac3|disc|cd|ts|ftl|tc|cam|telesync|telecine|german|englisch|deutsch|english|devine|screener|proper|limited|internal|repack|\[BT\]|hdtv|lol|S..E..|\.de|\.com|\.dl|\.am|www\.|bitleeching|\(|\)|0|1|2|3|4|5|6|7|8|9)/i", "", $purename);
									$search = str_replace("-", ".", $search);
									$search = preg_replace("/\s+/", " ", $search);
									$search = preg_replace("/\.+/", ".", $search);
									$search = str_replace(".", " ", $search);
									$search = chop($search);
							
									switch ($typ) {
										case "1":
											if ( $imdblink == "" ) {
												$imdblink = "http://epguides.master.com/texis/master/search/?q=". $search ."&xsubmit=Search&s=SS";
											}
											break;
										case "2":
											if ( $imdblink == "" ) {
												$imdblink = "http://www.imdb.com/find?q=". $search;
											}
											break;
										default:
											$imdblink = "-";
											break;
									}
									
									echo"scrape url: $scrape\r\n";
									echo"downloaded: $dld\r\n";
									echo"leecher: $incomp\r\n";
									echo"seeder: $comp\r\n";
									echo"added...\r\n\r\n";
									query($adbh, "INSERT INTO torrents (typ, name, wertung, anzwert, hinzugefuegt, groesse, uploader, dlname, beschreibung, views, hits, announce, hash, tr_downloaded, tr_incomplete, tr_complete, purename, imdblink, anzfiles, offsince, register) VALUES ('$typ', '$torrentname', '0', '0', '$aktdatetime', '$totallen', '$uploader', '$dname', '$desc', '0', '0', '$ann', '$enchash', '$dld', '$incomp', '$comp', '$purename', '$imdblink', '$anzfiles', '0', '0')");
	
/* genre-name aus db auslesen
*/
									$genres = query($adbh, "SELECT name FROM genres WHERE id = '$typ'");
									$grow = fetch_object($genres);
									$genre = $grow->name;
			
/*	ID aus db auslesen
*/
									$ids = query($adbh, "SELECT id FROM torrents WHERE hash = '$enchash'");
									$idrow = fetch_object($ids);
									$id = $idrow->id;
						
/*	RSS-Feed erstellen
*/							
/*	Altes RSS-File auslesen
*/
									$fp = @fopen("$rssfile","rb");
									if ( $fp ) {
										$inhalt = "";
										while ( !feof($fp) ) {
											$inhalt.= @fread($fp,1024);
										}
									}
									@fclose($fp);
	
/*	RSS-Feed-Array zusammenstellen
*/
	
									preg_match("/(<\?xml.*>)/i",$inhalt, $xmlhead);
									preg_match("/(<rss.*>)/i",$inhalt, $rsshead);
						
									preg_match("/<title>([^<]+)<\/title>/i",$inhalt, $title);
									preg_match("/<link>([^<]+)<\/link>/i",$inhalt, $link);
									preg_match("/<description>([^<]+)<\/description>/i",$inhalt, $description);
									
									$header = array( "title" => $title[1], "link" => $link[1], "description" => $description[1] );
									
									preg_match_all("/<item.*?>(.*?)<\/item>/is", $inhalt, $di);
						
									$items = array();
									for ( $i = 0; $i < count($di[1]); $i++ ) {
										preg_match("/<title>([^<]+)<\/title>/i",$di[1][$i], $title);
										preg_match("/<link>([^<]+)<\/link>/i",$di[1][$i], $ilink);
										preg_match("/<description>([^<]+)<\/description>/i",$di[1][$i], $description);
										preg_match("/<guid.*?>([^<]+)<\/guid.*?>/i",$di[1][$i], $guid);
										preg_match("/<pubdate>([^<]+)<\/pubdate>/i",$di[1][$i], $pubdate);
										$item = array ( "title" => "$title[1]", "link" => "$ilink[1]", "description" => "$description[1]", "guid" => "$guid[1]", "pubdate" => "$pubdate[1]" );
										array_push($items, $item);
									}
									
									$feed = array( "xmlhead" => "$xmlhead[0]", "rsshead" => "$rsshead[0]", "head" => array_merge($header), "items" => array_merge($items));
	
/*	Neuen Item-Eintrag erstellen
*/
	
									$rname = str_replace(" ", "%20", $name);
						
									$newitems = "\r\n\t\t\t<item>".
												"\r\n\t\t\t\t" . createtags("title", $genre .": ". htmlentities($purename)).
												"\r\n\t\t\t\t" . createtags("link", $yabtucurl ."data/php/download.inc.php?id=". $id).
												"\r\n\t\t\t\t" . createtags("description", htmlentities("Tracker: ". $ann ."<br />". $beschreibung)).
												"\r\n\t\t\t\t" . createtags("guid isPermaLink='false'", dechash($infohash)).
												"\r\n\t\t\t\t" . createtags("pubdate", $rsstime).
												"\r\n\t\t\t</item>";
	
	
/*	Alte Item-Eintraege anhaengen
*/
	
									for ( $ic = 0; $ic <= 10; $ic++ ) {
										$newitems = $newitems . "\r\n\t\t\t<item>".
													"\r\n\t\t\t\t" . createtags("title", $feed["items"][$ic]["title"]).
													"\r\n\t\t\t\t" . createtags("link", $feed["items"][$ic]["link"]).							
													"\r\n\t\t\t\t" . createtags("description", $feed["items"][$ic]["description"]).
													"\r\n\t\t\t\t" . createtags("guid isPermaLink='false'", $feed["items"][$ic]["guid"]).
													"\r\n\t\t\t\t" . createtags("pubdate", $feed["items"][$ic]["pubdate"]).
													"\r\n\t\t\t</item>";
									}
	
/*	Neues RSS-File zusammenstellen
*/
									$newfile =	$feed["xmlhead"] . "\r\n\t".
												$feed["rsshead"] . "\r\n\t\t".
												"<channel>" . "\r\n\t\t\t".
												createtags("title", $feed["head"]["title"]) . "\r\n\t\t\t".
												createtags("link", $feed["head"]["link"]) . "\r\n\t\t\t".
												createtags("description", $feed["head"]["description"]) . "\r\n".
												$newitems . "\r\n\t\t\t".
												"</channel>" . "\r\n\t".
												"</rss>" . "\r\n";
						
									$nr_of_bytes = 0;
									if ( ($file = fopen($rssfile, "wb+")) === false ) {
										echo "could not open file";
										die();
									}
									
									if ( ($nr_of_bytes = fwrite($file, $newfile)) === false) {
										echo "could not write to file";
										die();
									}
									fclose($file);
													
													
												}
											}					
										}
									}
								}
							} else {
								echo "Error: It's not possible to get $rssurl...\r\n";
							}
						}
?>
